use esp_idf_sys as _;
use std::thread;

mod beep;
mod blink;
fn main() {
    // Temporary. Will disappear once ESP-IDF 4.4 is released, but for now it is necessary to call this function once,
    // or else some patches to the runtime implemented by esp-idf-sys might not link properly.
    esp_idf_sys::link_patches();

    let peripherals = esp_idf_hal::peripherals::Peripherals::take().unwrap();

    let gpio5 = peripherals.pins.gpio5;
    let gpio6 = peripherals.pins.gpio6;
    let ledc_timer0 = peripherals.ledc.timer0;
    let ledc_channel0 = peripherals.ledc.channel0;
    thread::spawn(move || {
        let mut blink =
            blink::Blink::new(gpio5.into_output().expect("Failed to set GPIO5 as output"));
        blink.play();
    });

    thread::spawn(move || {
        let mut beep = beep::Beep::new(
            gpio6.into_output().expect("Failed to set GPIO6 as output"),
            ledc_timer0,
            ledc_channel0,
        )
        .expect("Failed to create beep");
        beep.play();
    });

    println!("Hello, world!");
}
